﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Security;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Moq;
using Scrum.Web;
using Scrum.Web.Helpers;
using Scrum.Web.Models.DAL;

namespace Scrum.Tests.Controllers
{
    [TestClass]
    public class BaseControllerTest
    {
        protected Mock<IRepository> _mockRepository;
        protected Mock<IScrumMembershipProvider> _mockScrumMembershipProvider;
        protected Mock<IScrumRoleProvider> _mockScrumRoleProvider;

        private const int USER_Admin_Id = 1;
        private const string USER__Admin_UserName = "edu";
        private const string USER_Admin_Email = "abc@abc.com";
        private const byte USER_Admin_IsAdmin = 1;
        private const byte USER_Admin_IsNotAdmin = 0;
        private const string USER_Admin_Password = "123456";

        [TestInitialize]
        public void BaseTestInitialize()
        {
            _mockRepository = new Mock<IRepository>();
            _mockScrumMembershipProvider = new Mock<IScrumMembershipProvider>();
            _mockScrumRoleProvider = new Mock<IScrumRoleProvider>();

            Bootstrapper.RegisterAutoMapper();
        }

        protected User GetUser_Admin()
        {
            return new User()
            {
                Name = USER__Admin_UserName,
                Email = USER_Admin_Email,
                UserId = USER_Admin_Id,
                IsAdmin = USER_Admin_IsAdmin,
                Password = USER_Admin_Password

            };
        }

        protected User GetUser_NoAdmim()
        {
            return new User()
            {
                Name = USER__Admin_UserName,
                Email = USER_Admin_Email,
                UserId = USER_Admin_Id,
                IsAdmin = USER_Admin_IsNotAdmin,
                Password = USER_Admin_Password

            };
        }

        protected MembershipUser GetMembershipUser_Admin()
        {
            return null;
        }

        protected void ResetCalls()
        {
            _mockRepository.ResetCalls();
            _mockScrumMembershipProvider.ResetCalls();
            _mockScrumRoleProvider.ResetCalls();
        }
    }
}
