﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using System.Globalization;
using System.Web.Security;

namespace Scrum.Web.Models
{
  
    public class PasswordModel
    {
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name="Id")]
        [Editable(false)]
        public int UserId { get; set; }
        
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [StringLength(100, ErrorMessage = "El número de caracteres de {0} debe ser al menos {2}.", MinimumLength = 6)]
        [DataType(DataType.Password)]
        [Display(Name = "Nueva contraseña")]
        public string NewPassword { get; set; }

        [DataType(DataType.Password)]
        [Display(Name = "Confirmar la nueva contraseña")]
        [Compare("NewPassword", ErrorMessage = "La nueva contraseña y la contraseña de confirmación no coinciden.")]
        public string ConfirmPassword { get; set; }

        [Display(Name = "Nombre de Usuario")]
        public string Name { get; set; }
    }

    public class PersonalDataEditModel
    {
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Id")]
        [Editable(false)]
        public int UserId { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom")]
        [Editable(false)]
        public string Name { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Correu electrònic")]
        [DataType(DataType.EmailAddress)]
        public string Email { get; set; }

        [StringLength(100, ErrorMessage = "El número de caràcters de {0} ha de ser com a mínim de {2}.", MinimumLength = 6)]
        [DataType(DataType.Password)]
        [Display(Name = "Nova contrasenya")]
        public string NewPassword { get; set; }

        [DataType(DataType.Password)]
        [Display(Name = "Confirmar la nova contrasenya")]
        [Compare("NewPassword", ErrorMessage = "La nova contrasenya i la contrasenya de confirmació no coincideixen.")]
        public string ConfirmPassword { get; set; }

        
    }

    public class LoginModel
    {
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Usuari")]
        public string UserName { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [DataType(DataType.Password)]
        [Display(Name = "Contrasenya")]
        public string Password { get; set; }

        [Display(Name = "Recordar credencials en aquest equip")]
        public bool RememberMe { get; set; }
    }

    public class RegisterModel
    {
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Usuari")]
        public string UserName { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [StringLength(100, ErrorMessage = "El número de caràcters de {0} debe ser al menos {2}.", MinimumLength = 6)]
        [DataType(DataType.Password)]
        [Display(Name = "Contrasenya")]
        public string Password { get; set; }

        [DataType(DataType.Password)]
        [Display(Name = "Confirmar contrasenya")]
        [Compare("Password", ErrorMessage = "La contrasenya i la contrasenya de confirmació no coincideixen.")]
        public string ConfirmPassword { get; set; }
    }

    
}
