﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Scrum.Web.Models.UI
{
    public class ProductBackLogListModel
    {
        [Display(Name = "Identificador")]
        public int ProjectId { get; set; }
        
        [Display(Name = "Nom curt")]
        public string ShortName { get; set; }

        [Display(Name = "Nom")]
        public string Name { get; set; }

        [Display(Name = "Nom")]
        public IEnumerable<ProductBackLogUserHistoryModel> UserHistories { get; set; }
    }

    public class ProductBackLogUserHistoryModel
    {
        public long UserHistoryId { get; set; }
        public int UserHistoryStatusId { get; set; }

        [Display(Name = "Prioritat")]
        public int Priority { get; set; }
        
        [Display(Name = "Nom")]
        public string Name { get; set; }

        [Display(Name = "Descripció")]
        [StringLength(2000)]
        public string Description { get; set; }

        [Display(Name = "Estimació")]
        public decimal Estimation { get; set; }

        public int ProjectId { get; set; }

        public bool CanDelete { get; set; }
    }

    public class ProductBackLogCreateModel
    {
      
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Estat")]
        public int UserHistoryStatusId { get; set; }

        [Display(Name = "Prioritat")]
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        public int Priority { get; set; }

        [Display(Name = "Nom")]
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        public string Name { get; set; }

        [Display(Name = "Descripció")]
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [StringLength(2000)]
        public string Description { get; set; }

        [Display(Name = "Estimació")]
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        public decimal Estimation { get; set; }

        public int ProjectId { get; set; }

        [Display(Name = "Nom projecte")]
        [Editable(false)]
        public string ProjectName { get; set; }

        public IEnumerable<ProductBackLogUserHistoryStatusModel> UserHistoryStatus { get; set; }
    }

    public class ProductBackLogUserHistoryStatusModel
    {
        public int UserHistoryStatusId { get; set; }
        public string Name { get; set; }
    }

    public class ProductBackLogEditModel
    {
        public long UserHistoryId { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Estat")]
        public int UserHistoryStatusId { get; set; }

        [Display(Name = "Prioritat")]
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        public int Priority { get; set; }

        [Display(Name = "Nom")]
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        public string Name { get; set; }

        [Display(Name = "Descripció")]
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [StringLength(2000)]
        public string Description { get; set; }

        [Display(Name = "Estimació")]
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        public decimal Estimation { get; set; }

        public int ProjectId { get; set; }

        [Display(Name = "Nom projecte")]
        [Editable(false)]
        public string ProjectName { get; set; }

        [Display(Name = "Estat")]
        [Editable(false)]
        public string UserHistoryStatusDescription { get; set; }
    }
}