﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Scrum.Web.Models.UI
{
    public class ProjectListModel
    {
        [Display(Name="Identificador")]
        public int ProjectId { get; set; }

        [Display(Name = "Nom curt")]
        public string ShortName { get; set; }

        [Display(Name = "Nom")]
        public string Name { get; set; }
    }

    public class ProjectCreateModel
    {
        [Display(Name = "Id")]
        [Editable(false)]
        public int? ProjectId { get; set; }
        
        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom curt")]
        public string ShortName { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom")]
        public string Name { get; set; }

    }

    public class ProjectEditModel
    {
        [Display(Name = "Id")]
        [Editable(false)]
        public int? ProjectId { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom curt")]
        public string ShortName { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom")]
        public string Name { get; set; }

    }

    public class ProjectDetailModel
    {
        [Display(Name = "Id")]
        [Editable(false)]
        public int? ProjectId { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom curt")]
        [Editable(false)]
        public string ShortName { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom")]
        [Editable(false)]
        public string Name { get; set; }

    }

    public class ProjectRoleListModel
    {
        [Display(Name = "Id")]
        [Editable(false)]
        public int? ProjectId { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom curt")]
        [Editable(false)]
        public string ShortName { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom")]
        [Editable(false)]
        public string Name { get; set; }

        public IEnumerable<ProjectRoleListModelUser> Owners { get; set; }
        public IEnumerable<ProjectRoleListModelUser> ScrumMasters { get; set; }
        public IEnumerable<ProjectRoleListModelUser> Developers { get; set; }

    }

    public class ProjectRoleListModelUser
    {
        [Display(Name = "Identificador")]
        public int UserId { get; set; }

        [Display(Name = "Nom")]
        public string Name { get; set; }

        [Display(Name = "Correu electrònic")]
        public string Email { get; set; }
    }

    public class ProjectCreateRoleModel
    {
        [Display(Name = "Identificador del projecte")]
        [Editable(false)]
        public int ProjectId { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom curt del projecte")]
        [Editable(false)]
        public string ProjectShortName { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom del projecte")]
        [Editable(false)]
        public string ProjectName { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Identificador del perfil")]
        [Editable(false)]
        public int ProfileId { get; set; }

        [Required(ErrorMessage="El camp {0} és obligatori.")]
        [Display(Name = "Nom del perfil")]
        [Editable(false)]
        public string ProfileName { get; set; }

        public IEnumerable<ProjectRoleListModelUser> Users { get; set; }

        [Required(ErrorMessage="El camp Usuari és obligatori")]
        [Display(Name = "Usuari")]
        public int SelectedUserId { get; set; }
    }
}